README
======

The C++ code follows the C++11 standard, tested with g++-4.9. 
It requires the [NLOpt][NLOpt] library for non-linear optimization. 
If you define "DEBUG" in the Makefile, then you'll need Wolfram Mathematica.

The Python code uses Python 3.x, tested with Python-3.4.1.

To mine the Frequent Itemsets from a dataset we used the [implementation by
Grahne and Zhu][GrahneZ03], available from
<http://fimi.ua.ac.be/src/fimi06.tgz>.

The code has been tested mostly on GNU/Linux. It may work also on other *NIX
flavours, including Mac OS X. It was never tried on Windows.

Installation
------------
Set your favourite C++ compiler in Makefile as `CPP`, and run `make`. 

Running
-------
At the beginning of each script or source code there is a short description of
what each script or corresponding binary does. You can also specify the `-h`
flag to get the help message for each script or binary.

The binary for the progressive sampling algorithm described in the paper is
`progressive_sampling`. The options to pass for the automatic sampling schedule,
the stopping condition, and the computation used in the paper are:

```
-a -s optimize -c refined
```

Use `-v` if you want verbose output on stderr.

[NLOpt]: http://ab-initio.mit.edu/wiki/index.php/NLopt "NLopt homepage"
[GrahneZ03]: http://ceur-ws.org/Vol-90/grahne.pdf "Efficiently Using Prefix-trees in Mining Frequent Itemsets"
